package cn.wch.ch934xuartdemo.ui;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;

import androidx.annotation.IdRes;

import cn.wch.ch934xuartdemo.utils.LogUtil;

public class MyRadioGroup extends RadioGroup {
    private boolean intercept=false;
    private OnCheckedChangeListener listener;

    private long lastTime=0;
    private int lastId=0;

    public MyRadioGroup(Context context) {
        super(context);
    }

    public MyRadioGroup(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    void init(){
        setOnCheckedChangeListener(changeListener);
    }

    private OnCheckedChangeListener changeListener=new OnCheckedChangeListener() {
        @Override
        public void onCheckedChanged(RadioGroup group, int checkedId) {
            //LogUtil.d(checkedId+" is checked"+group.getCheckedRadioButtonId());

            //avoid repeat
            if(checkedId==lastId && System.currentTimeMillis()-lastTime<100){
                //LogUtil.d("check: drop");
                return;
            }
            lastId=checkedId;
            lastTime=System.currentTimeMillis();

            if(intercept){
                //LogUtil.d("check: intercept");
                intercept=false;
                return;
            }
            if(listener!=null){
                listener.onCheckedChanged(group, checkedId);
            }
        }
    };

    public void setNewListener(OnCheckedChangeListener listener){
        this.listener=listener;
    }

    public void checkWithCallback(@IdRes int id){
        if(getCheckedRadioButtonId()==id){
            return;
        }
        LogUtil.d("set checked "+id);
        check(id);
    }

    public void checkWithoutCallback(@IdRes int id){
        if(getCheckedRadioButtonId()==id){
            return;
        }
        LogUtil.d("set checked "+id);
        intercept=true;
        check(id);

    }
}
