package cn.wch.ch934xuartdemo.ui;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.view.View.OnClickListener;

import androidx.annotation.Nullable;
import androidx.appcompat.widget.AppCompatTextView;

import cn.wch.ch934xlib.chip.Mode;

public class MyTextView extends AppCompatTextView {

    private OnMyClickListener listener;

    private final String s1="恢复普通模式";
    private final String s2="使能GPIO";

    public MyTextView(Context context) {
        super(context);
    }

    public MyTextView(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    public MyTextView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public void init(){
        setText(s1);
        setOnClickListener(clickListener);
    }

    public void setOnMyClickListener(OnMyClickListener listener){
        this.listener=listener;
    }

    private OnClickListener clickListener=new View.OnClickListener(){
        @Override
        public void onClick(View v) {
            if(getText().toString().equals(s1)){
                if(listener!=null){
                    listener.onDisEnableGPIO();
                }
            }else if(getText().toString().equals(s2)){
                if(listener!=null){
                    listener.onEnableGPIO();
                }
            }
        }
    };


    public void setCurrentMode(Mode mode){
        if(mode==Mode.GPIO){
            setText(s1);
        }else if(mode==Mode.NORMAL){
            setText(s2);
        }
    }


    public static interface OnMyClickListener{
        void onEnableGPIO();
        void onDisEnableGPIO();
    }
}
